routes/web.php
<?php

use App\Helpers\CustomerHelper;
use App\Http\Controllers\BillsController;
use App\Http\Controllers\CustomersController;
use App\Http\Controllers\CustomerWaresControler;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProductMarketController;
use App\Http\Controllers\ProductTemplateController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

/*------------------------------------------
--------------------------------------------
All Normal Users Routes List
--------------------------------------------
--------------------------------------------*/
Route::middleware(['auth', 'user-access:user'])->group(function () {

    Route::get('/home', [HomeController::class, 'index'])->name('home');
});

/*------------------------------------------
--------------------------------------------
All Admin Routes List
--------------------------------------------
--------------------------------------------*/
Route::middleware(['auth', 'user-access:admin'])->group(function () {

    //customers
    Route::resource('admin/customers', CustomersController::class);
    Route::get('admin/delete_subcategory', [CustomersController::class, 'delete_subcategory']);
    Route::get('admin/downloadPDF', [CustomersController::class, 'downloadPDF']);

    //helpers
    Route::get('admin/show_subcategory_by_category_id', [CustomerHelper::class, 'show_subcategory_by_category_id']);
    Route::get('admin/helper_add_subcategory', [CustomerHelper::class, 'helper_add_subcategory']);
    Route::get('admin/helper_add_subcategory', [CustomerHelper::class, 'helper_add_subcategory']);
    Route::get('admin/customers_autocomplete', [CustomerHelper::class, 'customers_autocomplete']);
    Route::get('admin/find_textiles_filters', [CustomerHelper::class, 'find_textiles_filters']);
    Route::get('admin/find_market_product', [CustomerHelper::class, 'find_market_product']);
    Route::get('admin/get_subcategoires_by_category_id', [CustomerHelper::class, 'get_subcategoires_by_category_id']);
    Route::get('admin/search_ware_name', [CustomerHelper::class, 'search_ware_name']);
    Route::get('admin/template_child_validator', [CustomerHelper::class, 'template_child_validator']);
    Route::get('admin/take_categories', [CustomerHelper::class, 'take_categories']);
    Route::get('admin/subcategories_for_category', [CustomerHelper::class, 'subcategories_for_category']);

//    Route::get('admin/customer/helper_add_subcategory', [CustomerHelper::class, 'helper_add_subcategory']);

    //ware
    Route::resource('admin/wares', CustomerWaresControler::class);
//    Route::get('admin/wares', [CustomerWaresControler::class, 'index']);

    //ware-textile
    Route::get('admin/textile', [CustomerWaresControler::class, 'customers_textile'])->name('textile');


    //bils
    Route::resource('admin/bills', BillsController::class);
//    Route::get('admin/bills', [BillsController::class, 'index']);
//    Route::get('admin/customers/{id}/create_bill', [BillsController::class, 'generate_bill'])->name('create_bill');
    Route::get("/admin/get_customer_coin", [CustomerHelper::class, 'get_customer_coin']);

    /*product template*/
    Route::resource('admin/templates', ProductTemplateController::class);
    Route::post('admin/templates/create_child_templates', [CustomerHelper::class, 'create_child_templates']);
    Route::get('admin/templates/show_template_child/{parent_id}/{child_id}', [ProductTemplateController::class, 'show_template_child'])->name('templates.show_template_child');
    Route::get('admin/templates/show_template_table/{parent_id}/{child_id}', [ProductTemplateController::class, 'show_template_table'])->name('templates.show_template_table');

    /*product market route*/
    Route::resource('admin/market', ProductMarketController::class);


});

/*------------------------------------------
--------------------------------------------
All Admin Routes List
--------------------------------------------
--------------------------------------------*/
Route::middleware(['auth', 'user-access:manager'])->group(function () {

    Route::get('/manager/home', [HomeController::class, 'managerHome'])->name('manager.home');
});

app/Http/Controllers/CustomersController.php
<?php

namespace App\Http\Controllers;

use App\Helpers\CustomerHelper;
use App\Models\Bills;
use App\Models\Customers;
use App\Models\Products;
use Barryvdh\DomPDF\Facade\Pdf;
use Dflydev\DotAccessData\Data;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class CustomersController extends Controller
{

    public Products $product;
    public Customers $customers;
    public Bills $bills;
    public CustomerHelper $helper;

    public function __construct()
    {
        $this->product = new Products();
        $this->customers = new Customers();
        $this->helper = new CustomerHelper();
        $this->bills = new Bills();
    }

    public function index(Request $request)
    {
        $product = new Products();

        if ($request->input()) {

            $data = $this->helper->helper_show_filter($request->input());
            $data['filtering_criteria'] = array(
                'customer_name' => $request->input('customer_name'),
                'type' => $request->input('type'),
                'category' => $this->product->get_customer_category_by_id($request->input('category')),
            );
        }

        $data['customers'] = $this->customers->get_customers_after_filter(
            $request->input('customer_name'),
            $request->input('type'),
            $request->input('category')
        );

        if ($request->input('downloadPDF') == 'PDF') {
            $pdf = PDF::loadView('customers.pdf', $data);
            return $pdf->download('invoice.pdf');
        }
        $data['furnace_categories'] = $product->get_furnace_categories();

        return view('customers.index', $data)
            ->with('i', (request()->input('page', 1) - 1) * 5);
    }

    public function create()
    {
        $customerCountries = array(
            1 => 'Romania',
            2 => 'UE',
            3 => 'non-UE'
        );
        $product = new Products();
        $data['furnace_categories'] = $product->get_furnace_categories();
        $data['subcategories'] = $product->get_subcategory_for_customer_category();

        $data['countries'] = $customerCountries;

        return view('customers.create', $data);
    }

    public function store(Request $request)
    {
        //         dd($request->input());
        if ($request->input('type') == 'Provider') {
            $request->validate([
                'name' => 'required',
                'type' => 'required',
                'unique_code' => 'required',
                'country' => 'required',
                //                'categories_id' => 'required'
            ]);
        } else {
            $request->validate([
                'name' => 'required',
                'type' => 'required',
                'unique_code' => 'required',
                'country' => 'required',
            ]);
        }
        $data = $request->input();

        if ($request->input('type') == 'provider') {

            $categories_id = (array)$request->input('categories_id');
            //            if (!in_array(8, $categories_id)) {
            //                $request->validate([
            //                    'subcategories_id' => 'required',
            //                ]);
            //            }
            $customer = Customers::create($data);
            $categories_id = $request->input('categories_id');
            $subcategories_id = $request->input('subcategories_id');
            $this->product->set_customer_categories_and_subcategories($customer->id, $categories_id, $subcategories_id);
        } else {
            Customers::create($data);
        }

        return redirect()->route('customers.index')
            ->with('success', 'customer created successfully.');
    }


    //    public function show(Customers $customer)
    //    {
    //
    //    }

    public function edit(Customers $customer)
    {
        $customerCountries = array(
            1 => 'Romania',
            2 => 'UE',
            3 => 'non-UE'
        );
        $data['countries'] = $customerCountries;
        $product = new Products();
        $data['furnace_categories'] = $product->get_furnace_categories();
        $data['subcategories'] = $product->get_subcategory_for_customer_category();

        if ($customer->attributesToArray()['type'] == 'provider') {
            $data['customers'] = $this->customers->get_customer_and_categories_by_id($customer->attributesToArray()['id']);
        } else {
            $data['customers'] = $customer;
        }

        return view('customers.edit', $data);
    }

    public function update(Request $request, Customers $customer)
    {


        $request->validate([
            'name' => 'required',
            'unique_code' => 'required',
            'country' => 'required',
        ]);

        $data = $request->input();

        if ($customer->attributesToArray()['type'] == 'provider') {

            $subcategories_id = $request->input('subcategories_id');
            $categories_id = (array)$request->input('categories_id');

            $this->product->update_customer_categories_and_subcategories($customer->attributesToArray()['id'], $categories_id, $subcategories_id);
        }

        $customer->update($data);

        return redirect()->route('customers.index')
            ->with('success', 'customer updated successfully');
    }

    public function destroy(Customers $customer)
    {

        $result = $this->customers->delete_customer($customer->attributesToArray()['id']);
        $message = 'Client sters cu succes';

        if (!$result) {
            $message = 'Clientul nu a fost sters, a aparut o eroare';
        }

        return redirect()->route('customers.index')
            ->with('success', $message);
    }


    public function delete_subcategory(Request $subcategory_id)
    {
        dump($subcategory_id->id);
        //when an item is deleted from customer create

        $products = new Products();
        $products->delete_subcategory_by($subcategory_id->id);
    }
}

resources/views/customers/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Add New Product</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('customers.index') }}"> Renunta</a>
            </div>
        </div>
    </div>

    @if ($errors->any())

        <div class="alert alert-danger">
            @foreach ($errors->all() as $error)
                <p>{{ $error }}</p>
            @endforeach
        </div>

    @endif

    <form action="{{ route('customers.store') }}" method="POST">
        @csrf
        <div class="form-check">
            <input type="checkbox" class="form-check-input" id="checkCustomer" name="type" onclick="checkBoxCustomer()"
                   value="customer">
            <label class="form-check-label" for="checkCustomer">Beneficiar</label>
        </div>


        <div class="form-check">
            <input type="checkbox" class="form-check-input" id="checkProvider" name="type"
                   onclick="checkBoxProvider()" value="provider">
            <label class="form-check-label" for="check2">Furnizor</label>
        </div>

        <div class="col-xs-1 col-sm-12 col-md-5  show-subcategory" id="categoryProduct"
             style="padding-left: 65px; display: none">
            <strong>Categorii:</strong>
            <br>

            @foreach ($furnace_categories as $furnace_category)

                <input type="checkbox"
                       id="category_id{{$furnace_category->id}}"
                       onclick="showSubcategoryByCategoryId({{$furnace_category->id}})"
                       class=""
                       name="categories_id[]"
                       value="{{ $furnace_category->id }}"
                >
                <label>{{ $furnace_category->name }}</label>
                <br>

                <div class="card subcategory-card" id="subcategory{{$furnace_category->id}}">
                    <div id="subcategory_list{{$furnace_category->id}}"></div>

                    @if($furnace_category->id != 8)
                        <div id="subcategory_box{{$furnace_category->id}}" style="display: none">
                            <input placeholder="add subcategory" type="text"
                                   id="subcategoryLabel{{$furnace_category->id}}">
                            <input onclick="addSubcategoryForCustomersId({{$furnace_category->id}})"
                                   type="button" value="Add">
                        </div>
                    @endif
                </div>

            @endforeach
        </div>


        <div id="customerOrProviderForm" style="display: none">
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">

                        <strong> <i class="fa fa-asterisk" style="font-size:7px;color:red; vertical-align: top;"></i>Name:</strong>
                        <input type="text" name="name" class="form-control" placeholder="Name ">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong><i class="fa fa-asterisk" style="font-size:7px;color:red; vertical-align: top;"></i>Cod:</strong>
                        <input type="number" name="unique_code" class="form-control" placeholder="Cod ">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Adresa:</strong>
                        <input type="text" name="address" class="form-control" placeholder="Adresa">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Cod Postal:</strong>
                        <input type="number" name="zip_code" class="form-control" placeholder="Cod Postal">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong><i class="fa fa-asterisk" style="font-size:7px;color:red; vertical-align: top;"></i>Oras
                            :</strong>
                        <input type="text" name="city" class="form-control" placeholder="Oras">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <strong><i class="fa fa-asterisk"
                               style="font-size:7px;color:red; vertical-align: top;"></i>Tara:</strong>
                    <select name="country" id="department" class="form-control">
                        <option value=""> -- Selecteaza o Tara --</option>
                        @php($i = 1)
                        @foreach ($countries as $country)
                            <option value="{{$i}}">{{ $country }}</option>
                            @php($i++)
                        @endforeach
                    </select>
                </div>


                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>CIF :</strong>
                        <input type="text" name="cif" class="form-control" placeholder="CIF">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>OCR :</strong>
                        <input type="text" name="ocr" class="form-control" placeholder="OCR">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>IBAN :</strong>
                        <input type="text" name="iban" class="form-control" placeholder="IBAN">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>SWIFT :</strong>
                        <input type="text" name="swift" class="form-control" placeholder="SWIFT">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>BANCA :</strong>
                        <input type="text" name="bank" class="form-control" placeholder="BANCA">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>CONTACT :</strong>
                        <input type="text" name="contact" class="form-control" placeholder="CONTACT">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Telefon 1:</strong>
                        <input type="number" name="phone" class="form-control" placeholder="Telefon 1">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Telefon 2:</strong>
                        <input type="number" name="phone2" class="form-control" placeholder="Telefon 2">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>E-mail:</strong>
                        <input type="text" name="email" class="form-control" placeholder="E-mail">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>WWW:</strong>
                        <input type="text" name="www" class="form-control" placeholder="www">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Note:</strong>
                        <textarea class="form-control" style="height:70px" name="note" placeholder="Note"></textarea>
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                    <button type="submit" class="btn btn-primary">Creeaza</button>
                </div>
            </div>
        </div>
    </form>

@endsection

resources/views/customers/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Editeazal pe {{$customers->name}}</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('customers.index') }}"> Renunta</a>
            </div>
        </div>
    </div>

    @if ($errors->any())

        <div class="alert alert-danger">
            @foreach ($errors->all() as $error)
                <p>{{ $error }}</p>
            @endforeach
        </div>

    @endif

    <form action="{{ route('customers.update',$customers->id) }}" method="POST">

        @csrf
        @method('PUT')

        @if($customers->type == 'provider')

            <input type="hidden" name="customer_id" value="{{ $customers->id }}">

            <div class="col-xs-1 col-sm-12 col-md-5 show-subcategory">

                <strong id="category"
                        @php
                            $categories = array();
                            $i = 0;
                                foreach($customers->categories as $category) {
                                    $categories[$category->category_id] =(array)$category->category_id;
                                    $i++;
                                }
                        @endphp
                        customer_id="{{$customers->id}}"
                        categories="{{ json_encode($customers->categories) }}"
                >Categorii:</strong>
                <br>

                @foreach ($furnace_categories as $furnace_category)
                    <input type="checkbox"
                           id="category_id{{$furnace_category->id}}"
                           onclick="showSubcategoryByCategoryId({{$furnace_category->id}}, {{ json_encode($customers->categories) }})"
                           name="categories_id[]"
                           value="{{ $furnace_category->id }}"
                           @if($categories[$furnace_category->id] ?? ''== $furnace_category->id)
                               checked
                        @endif
                    >
                    <label>{{ $furnace_category->name }}</label>

                    <br>

                    <div class="card subcategory-card" id="subcategory{{$furnace_category->id}}">
                        <div id="subcategory_list{{$furnace_category->id}}"></div>

                        <div id="subcategory_box{{$furnace_category->id}}" style="display: none">
                            @if($furnace_category->id != 8)

                                <input placeholder="add subcategory" type="text"
                                       id="subcategoryLabel{{$furnace_category->id}}">
                                <input onclick="addSubcategoryForCustomersId({{$furnace_category->id}})"
                                       type="button" value="Add">

                            @endif
                        </div>
                    </div>

                @endforeach
            </div>


            <div class="col-xs-1 col-sm-12 col-md-6" style="padding-left: 130px;">

                {{--                <div class="searchable">--}}
                {{--                    <input type="text"--}}
                {{--                           autoComplete='none'--}}
                {{--                           name="subcategory"--}}
                {{--                           class="show-subcategory"--}}
                {{--                           value="{{$customers['subcategory_id']['name'] ?? ''}}" placeholder="search countries"--}}
                {{--                           onkeyup="filterFunction(this,event)">--}}
                {{--                    <ul id="ddlNationality">--}}

                {{--                    </ul>--}}
                {{--                </div>--}}


            </div>
        @endif
        <div id="customerOrProviderForm">
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong><i class="fa fa-asterisk" style="font-size:7px;color:red; vertical-align: top;"></i>Name:</strong>
                        <input type="text" name="name" class="form-control" placeholder="Name"
                               value="{{$customers->name}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong><i class="fa fa-asterisk" style="font-size:7px;color:red; vertical-align: top;"></i>Cod:</strong>
                        <input type="number" name="unique_code" class="form-control" placeholder="Cod"
                               value="{{$customers->unique_code}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Adresa:</strong>
                        <input type="text" name="address" class="form-control" placeholder="Adresa"
                               value="{{$customers->address}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Cod Postal:</strong>
                        <input type="number" name="zip_code" class="form-control" placeholder="Cod Postal"
                               value="{{$customers->zip_code}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong><i class="fa fa-asterisk" style="font-size:7px;color:red; vertical-align: top;"></i>Oras
                            :</strong>
                        <input type="text" name="city" class="form-control" placeholder="Oras"
                               value="{{$customers->city}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <strong><i class="fa fa-asterisk"
                               style="font-size:7px;color:red; vertical-align: top;"></i>Tara:</strong>
                    <select name="country" id="department" class="form-control">
                        <option value="{{$customers->country}}"> {{$countries[$customers->country]}} </option>
                        @php($i = 1)
                        @foreach ($countries as $country)
                            @if($i != $customers->country)
                                <option value="{{$i}}">{{ $country }}</option>
                            @endif
                            @php($i++)
                        @endforeach
                    </select>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>CIF :</strong>
                        <input type="text" name="cif" class="form-control" placeholder="CIF"
                               value="{{$customers->cif}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>OCR :</strong>
                        <input type="text" name="ocr" class="form-control" placeholder="OCR"
                               value="{{$customers->ocr}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>IBAN :</strong>
                        <input type="text" name="iban" class="form-control" placeholder="IBAN"
                               value="{{$customers->iban}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>SWIFT :</strong>
                        <input type="text" name="swift" class="form-control" placeholder="SWIFT"
                               value="{{$customers->swift}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>BANCA :</strong>
                        <input type="text" name="bank" class="form-control" placeholder="BANCA"
                               value="{{$customers->bank}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>CONTACT :</strong>
                        <input type="text" name="contact" class="form-control" placeholder="CONTACT"
                               value="{{$customers->contact}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Telefon 1:</strong>
                        <input type="number" name="phone" class="form-control" placeholder="Telefon 1"
                               value="{{$customers->phone}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Telefon 2:</strong>
                        <input type="number" name="phone2" class="form-control" placeholder="Telefon 2"
                               value="{{$customers->phone2}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>e-mail:</strong>
                        <input type="text" name="email" class="form-control" placeholder="e-mail"
                               value="{{$customers->email}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>www:</strong>
                        <input type="text" name="www" class="form-control" placeholder="www"
                               value="{{$customers->www}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Note:</strong>
                        <input class="form-control" style="height:70px" name="note" placeholder="Note"
                               value="{{$customers->note}}">
                    </div>
                </div>

                <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                    <button type="submit" class="btn btn-primary">Editeaza</button>
                </div>
            </div>
        </div>
    </form>

@endsection